#============================================================================================================================================#
# -*- coding:Utf-8 -*-
# say_sound V1.1p (29/01/2008) by DoCky 
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL




import es, os, psyco, keyvalues as _ke, random as _ra, playerlib as _pl
psyco.full()

ss_info = es.AddonInfo()
ss_info.version = "1.1p"
ss_info.author = "DoCky"
ss_info.name = "say_sound"
ss_info.url = "http://addons.eventscripts.com/addons/user/11751"

ss_game = {"Counter-Strike: Source" : "/cstrike", "Day of Defeat: Source" : "/dod", "Day of Defeat" : "/dod"} 
ss_path = os.getcwd() + ss_game[es.getgame()] + "/cfg/say_sound/"



#    SYSTEM    #
class System:
    """
        Script system
    """

    _down = es.ServerVar("ss_down")
    _user = es.ServerVar("ss_user")
    _volu = es.ServerVar("ss_volu")

    _keys = _ke.KeyValues(name="ss_list")
    _list = []
    _file = []


    @staticmethod
    def loadConf():
        if not os.path.isfile(ss_path + "config.cfg"):
            es.log("[say_sound] missing file : cfg/say_sound/ss_list.txt")

        else:
            es.ServerVar(ss_info.name, ss_info.version, "version actuelle du script").makepublic()
            es.ForceServerCommand("es_xmexec ../cfg/say_sound/config.cfg")
            es.log("[say_sound] config loaded")


    @staticmethod
    def keyGroup():
        if not os.path.isfile(ss_path + "ss_list.txt"):
            es.log("[say_sound] missing file : cfg/say_sound/ss_list.txt")
            es.log("[say_sound] file created : you must edit it")

            System._keys["my word"] = _ke.KeyValues(name="my word")
            System._keys["my word"]["1"] = "EDIT : my file/my sound 1.mp3"
            System._keys.save("cfg/say_sound/ss_list.txt")

        else:
            System._keys.load("cfg/say_sound/ss_list.txt")

            for word in System._keys:
                if word.keys():
                    System._list.append(word.getName())

                    for path in word.keys():
                        System._file.append("sound/" + System._keys[word.getName()][path])


    @staticmethod
    def downLoad():
        if int(System._down):
            es.log("[say_sound] files will be downloaded")

            for path in System._file:
                es.stringtable("downloadables", path)

        else:
            es.log("[say_sound] files will not be downloaded")




#    EVENT    #
def load():
    System.loadConf()
    System.keyGroup()
    System.downLoad()


def es_map_start(event_var):
    System.loadConf()
    System.keyGroup()
    System.downLoad()


def player_say(event_var):
    if event_var["text"] in System._list:
        path = System._keys[event_var["text"]][str(_ra.randint(1, len(System._keys[event_var["text"]].keys())))]

        if int(System._user):
            es.playsound(event_var["userid"], path, int(System._volu))

        else:
            for user in _pl.getUseridList("#human"):
                es.playsound(user, path, int(System._volu))

#============================================================================================================================================#
